3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be taken to unexpected places. If you
10 # like CDPATH, define it for your interactive shell sessions without
12 # But we protect ourselves from such a user mistake nevertheless.
15 # Similarly for IFS, but some shells (e.g. FreeBSD 7.2) are buggy and
16 # do not equate an unset IFS with IFS with the default, so here is
17 # an explicit SP HT LF.
21 git_broken_path_fix
() {
32 case "$SANE_TOOL_PATH:$elem" in
33 (?
*:/bin | ?
*:/usr
/bin
)
34 path
="$path$sep$SANE_TOOL_PATH"
50 die_with_status
1 "$@"
63 if test -z "$GIT_QUIET"
69 if test -n "$OPTIONS_SPEC"; then
76 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
77 parseopt_extra
="--keep-dashdash"
80 echo "$OPTIONS_SPEC" |
81 git rev-parse --parseopt $parseopt_extra -- "$@
" ||
85 dashless
=$
(basename "$0" |
sed -e 's/-/ /')
87 die
"Usage: $dashless $USAGE"
90 if [ -z "$LONG_USAGE" ]
92 LONG_USAGE
="Usage: $dashless $USAGE"
94 LONG_USAGE
="Usage: $dashless $USAGE
106 set_reflog_action
() {
107 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
109 GIT_REFLOG_ACTION
="$*"
110 export GIT_REFLOG_ACTION
115 if test -z "${GIT_EDITOR:+set}"
117 GIT_EDITOR
="$(git var GIT_EDITOR)" ||
return $?
120 eval "$GIT_EDITOR" '"$@"'
126 GIT_PAGER
=$
(git var GIT_PAGER
)
133 eval "$GIT_PAGER" '"$@"'
137 GREP_OPTIONS
= LC_ALL
=C
grep "$@"
141 GREP_OPTIONS
= LC_ALL
=C
egrep "$@"
144 is_bare_repository
() {
145 git rev-parse
--is-bare-repository
149 cdup
=$
(git rev-parse
--show-toplevel) &&
151 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
156 require_work_tree_exists
() {
157 if test "z$(git rev-parse --is-bare-repository)" != zfalse
159 die
"fatal: $0 cannot be used without a working tree."
163 require_work_tree
() {
164 test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true ||
165 die
"fatal: $0 cannot be used without a working tree."
168 require_clean_work_tree
() {
169 git rev-parse
--verify HEAD
>/dev
/null ||
exit 1
170 git update-index
-q --ignore-submodules --refresh
173 if ! git diff-files
--quiet --ignore-submodules
175 echo >&2 "Cannot $1: You have unstaged changes."
179 if ! git diff-index
--cached --quiet --ignore-submodules HEAD
--
183 echo >&2 "Cannot $1: Your index contains uncommitted changes."
185 echo >&2 "Additionally, your index contains uncommitted changes."
192 test -n "$2" && echo >&2 "$2"
197 # Generate a sed script to parse identities from a commit.
199 # Reads the commit from stdin, which should be in raw format (e.g., from
200 # cat-file or "--pretty=raw").
202 # The first argument specifies the ident line to parse (e.g., "author"), and
203 # the second specifies the environment variable to put it in (e.g., "AUTHOR"
204 # for "GIT_AUTHOR_*"). Multiple pairs can be given to parse author and
206 pick_ident_script
() {
215 s/^$lid "'\([^<]*\) <[^>]*> .*$/\1/'"
216 s/.*/GIT_${uid}_NAME='&'/p
219 s/^$lid "'[^<]* <\([^>]*\)> .*$/\1/'"
220 s/.*/GIT_${uid}_EMAIL='&'/p
223 s/^$lid "'[^<]* <[^>]*> \(.*\)$/@\1/'"
224 s/.*/GIT_${uid}_DATE='&'/p
231 # Create a pick-script as above and feed it to sed. Stdout is suitable for
233 parse_ident_from_commit
() {
234 LANG
=C LC_ALL
=C
sed -ne "$(pick_ident_script "$@
")"
237 # Parse the author from a commit given as an argument. Stdout is suitable for
238 # feeding to eval to set the usual GIT_* ident variables.
239 get_author_ident_from_commit
() {
240 encoding
=$
(git config i18n.commitencoding ||
echo UTF-8
)
241 git show
-s --pretty=raw
--encoding="$encoding" "$1" -- |
242 parse_ident_from_commit author AUTHOR
245 # Clear repo-local GIT_* environment variables. Useful when switching to
246 # another repository (e.g. when entering a submodule). See also the env
247 # list in git_connect()
248 clear_local_git_env
() {
249 unset $
(git rev-parse
--local-env-vars)
253 # Platform specific tweaks to work around some commands
256 # Windows has its own (incompatible) sort and find
263 # git sees Windows-style pwd
267 is_absolute_path
() {
276 is_absolute_path
() {
285 # Make sure we are in a valid repository of a vintage we understand,
286 # if we require to be in a git repository.
287 if test -z "$NONGIT_OK"
289 GIT_DIR
=$
(git rev-parse
--git-dir) ||
exit
290 if [ -z "$SUBDIRECTORY_OK" ]
292 test -z "$(git rev-parse --show-cdup)" ||
{
294 echo >&2 "You need to run this command from the toplevel of the working tree."
298 test -n "$GIT_DIR" && GIT_DIR
=$
(cd "$GIT_DIR" && pwd) ||
{
299 echo >&2 "Unable to determine absolute path of git directory"
302 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}